from libc.so

voc: libc
libc
 1 import exit
 3 import write
 3 import read
 2 import open
 1 import close
 2 import chmod
 variable buffer
 variable file
^

forth
here default: bye ]    libc 0 exit ^ ;
here default: emit ]   libc buffer c! 1 buffer 1 write drop ^ ;
here default: type ]   libc 1 -rot write drop ^ ;
here default: key ]    libc 1 buffer 1 read drop buffer c@ ^ ;
here default: clear ]  27 emit s" [2J" type 27 emit s" [1;1H" type ;

: choose vector ;
: use vector wsparse choose ;
: reload vector ;
: save vector ;

loc:
  create fname 256 allot
  : erase fname 256 0 fill ;
  here is choose ] erase fname swap move ;

  : set-perm fname 438 libc chmod drop ^ ;
  : open fname 66 libc open file ! ^ ;
  : close libc file @ close drop ^ ;

  : read-contents libc file @ ^ there #-of-blocks 512 * libc read drop ^ ;
  here is reload ] open read-contents close ;

  : write-contents libc file @ ^ there #-of-blocks 512 * libc write drop ^ ;
  here is save ] open set-perm write-contents close ;
;loc
: load new use reload ;


loc:
  : obtain >in @ 0 import last @ :xt @ 5 + @ swap >in ! ;
  : mark last @ here ;
  : revert h0 ! last ! ;
  : finalize imported? if constant ;then drop wsparse 2drop ;
  here ] mark >r >r obtain r> r> revert finalize ;
;loc is import-var

create: callback
  $52515358 , $89555657 , $40ec83e6 , $00000ae8 , $40c48300 ,
  $5a5f5e5d , $ffc35b59 , $e0 1,

: -f load \f ;

loc:
  <buffer> 128 512 * + constant where
  : adjust  where b0 ! ;
  : cleanup <buffer> b0 ! ;
  here ] adjust  new -f new cleanup ;
;loc is include

loc:
  : to-filename 1+ repeat dup c@ 0 =if 1+ ;then 1+ again ;
  : clean  1+ repeat dup c@ 0 =if 32 over c! ;then 1+ again ;
  : change >r to-filename dup r> 1- for clean next ;
  cmdline #args
  here ] dup 1 >if change over - eval ;then 2drop ;
;loc execute
